<?php

/*
*** PHP Script welches Daten aus Wechselrichter ausliest, parst und an homeserver schickt
*** Dieses Script wird per CRON aufgerufen
***
*/


// Daten abhohlen und parsen
$data = "" ;
$json = file_get_contents('http://<wechselrichter-ip>/getentries.cgi?oids=11365,11367,11368,11369,11395,11397,11650,11760,11762,11767,19035,19037');
$erg = json_decode($json);
for ($i = 0 ; $i <= count($erg)-1 ; $i++) {
        $mist = 'Label="' . $erg[$i]->label . '"' ;
        $mist .= ";" ;
        $mist .= 'Wert="' . (floatval($erg[$i]->val)*floatval($erg[$i]->factor)) . '"' ;
        $mist .= "\r\n";

        if ($erg[$i]->label == "SystemState.Global.Measurement.ExternalS0Power") {
                $data .= "Stromverbrauch=\"".(floatval($erg[$i]->val)*floatval($erg[$i]->factor))."\"\r\n";
        }
        if ($erg[$i]->label == "SystemState.Global.Measurement.AcPowerTotal") {
                $data .= "Stromerzeugung=\"".(floatval($erg[$i]->val)*floatval($erg[$i]->factor))."\"\r\n";
        }
}


// Daten an Homeserver senden
if (($socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP)) === false) {
    echo "socket_create() fehlgeschlagen: Grund: " . socket_strerror(socket_last_error()) . "\n";
}
$result = socket_connect($socket, "192.168.178.Z", 11110);
if ($result === false) {
    echo "socket_connect() fehlgeschlagen.\nGrund: ($result) " . socket_strerror(socket_last_error($socket)) . "\n";
}
socket_write($socket, $data, strlen($data));
socket_close($socket);

?>[